package cz.muni.fi.pa165.facade;

import cz.muni.fi.pa165.dto.TeamDTO;
import cz.muni.fi.pa165.dto.TournamentDTO;
import cz.muni.fi.pa165.entity.TeamEntity;
import cz.muni.fi.pa165.entity.TournamentEntity;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

/**
 * @author mvalko
 */
public interface TournamentFacade {

    /**
     * Get all tournaments given by city using services
     * @param cityName cityname to filter tournaments
     * @return list of tournaments in given city
     */
    List<TournamentDTO> getTournamentByCity(String cityName);

    /**
     * Get all tournaments given by team that won the tournaments
     * @param team team that won tournament
     * @return list of tournaments won by a given team
     */
    List<TournamentDTO> getTournamentsWonBy(TeamEntity team);

    List<TournamentDTO> findAllTournament();

    TournamentDTO getTournamentById(String uuid);

    String createTournament(TournamentDTO tournamentDTO);

    void delete(String uuid);
}
