package cz.muni.fi.pa165.entity;

import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Cascade;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import java.util.HashSet;
import java.util.Set;

/**
 * @author mvalko
 */

@Setter
@Getter
@Entity
public class PlayerEntity extends PersonEntity {

    @ManyToOne(cascade = CascadeType.PERSIST)
    @JoinColumn(name = "team_id_player")
    private TeamEntity team;

    @ManyToMany(mappedBy = "players",cascade = CascadeType.PERSIST)
    private Set<MatchEntity> matches = new HashSet<>();

    private int killStat;

    private int deathStat;

    private int assistStat;

    public PlayerEntity() {
    }

    public PlayerEntity(String name){
        super(name);
    }
}
