//package cz.muni.fi.pa165.entity;
//
//import cz.muni.fi.pa165.enums.CountryEnum;
//import cz.muni.fi.pa165.enums.TournamentFormat;
//import org.junit.jupiter.api.AfterAll;
//import org.junit.jupiter.api.BeforeAll;
//import org.junit.jupiter.api.Test;
//import org.junit.jupiter.api.TestInstance;
//
//import javax.persistence.EntityManager;
//import javax.persistence.EntityManagerFactory;
//import javax.persistence.Persistence;
//import java.time.LocalDate;
//import java.util.HashSet;
//import java.util.List;
//
//import static org.junit.jupiter.api.Assertions.assertEquals;
//import static org.junit.jupiter.api.Assertions.assertNull;
//
///**
// * @author Marek Kadlečík
// */
//@TestInstance(TestInstance.Lifecycle.PER_CLASS)
//public class TeamCoachEntityTest {
//
//    private final EntityManagerFactory emf = Persistence.createEntityManagerFactory("default");
//
//    private TeamCoachEntity teamCoachA;
//    private TeamCoachEntity teamCoachB;
//    private TeamCoachEntity teamCoachC;
//    private TeamCoachEntity teamCoachD;
//    private TeamCoachEntity teamCoachE;
//    private TeamEntity teamA;
//    private TeamEntity teamB;
//    private TeamEntity teamC;
//    private PlayerEntity playerA;
//    private TournamentEntity tournamentA;
//    private final LocalDate BIRTH_DATE = LocalDate.of(2022,2,2);  // 22.2.2022  22:22:22
//
//    @BeforeAll
//    void init() {
//        teamCoachA = new TeamCoachEntity("AutistaLeader");
//        teamCoachA.setCountry(CountryEnum.JAPAN);
//        teamCoachA.setDateOfBirth(BIRTH_DATE);
//        teamCoachB = new TeamCoachEntity("Chiky");
//        teamA = new TeamEntity("TeamA", new HashSet<>(List.of(teamCoachB)));
//        teamCoachB.setTeam(teamA);
//        teamA.setCoachList(new HashSet<>(List.of(teamCoachA,teamCoachB)));
//        teamCoachA.setTeam(teamA);
//        playerA = new PlayerEntity("Orik");
//        teamCoachB.addPlayerToTheTeam(playerA);
//        playerA.setTeam(teamA);
//
//        teamCoachC = new TeamCoachEntity("Borat");
//        teamCoachC.setCountry(CountryEnum.HUNGARY);
//        teamCoachC.setDateOfBirth(BIRTH_DATE);
//        teamB = new TeamEntity("TeamB", new HashSet<>(List.of(teamCoachC)));
//        teamCoachD = new TeamCoachEntity("Jupiter");
//        teamCoachD.setCountry(CountryEnum.LAOS);
//        teamCoachD.setDateOfBirth(LocalDate.of(1990,12,1));
//        teamCoachC.setTeam(teamB);
//        teamCoachC.addCoachToTheTeam(teamCoachD);
//        PlayerEntity playerB = new PlayerEntity("Kiro");
//        teamB.setPlayerList(new HashSet<>(List.of(playerB)));
//        teamCoachD.removePlayerFromTheTeam(playerB);
//
//        teamCoachE = new TeamCoachEntity("Curry");
//        TeamCoachEntity teamCoachF = new TeamCoachEntity("Idiol");
//        teamC = new TeamEntity("TeamC", new HashSet<>(List.of(teamCoachE, teamCoachF)));
//        teamCoachE.setTeam(teamC);
//        teamCoachF.setTeam(teamC);
//        teamCoachE.removeCoachFromTheTeam(teamCoachF);
//        tournamentA = new TournamentEntity("Zilina", CountryEnum.SLOVAKIA,1000, TournamentFormat.DEFAULT,5);
//        teamCoachE.signForTournament(tournamentA);
//        tournamentA.addTeamToTournament(teamC);
//
//        EntityManager em = emf.createEntityManager();
//        try {
//            em.getTransaction().begin();
//            em.persist(teamCoachA);
//            em.persist(teamCoachB);
//            em.persist(teamA);
//            em.persist(playerA);
//
//            em.persist(teamCoachC);
//            em.persist(teamCoachD);
//            em.persist(teamB);
//            em.persist(playerB);
//
//            em.persist(teamCoachE);
//            em.persist(teamCoachF);
//            em.persist(teamC);
//            em.persist(tournamentA);
//            em.getTransaction().commit();
//        } finally {
//            if (em != null) em.close();
//        }
//    }
//    /**
//     * Checks attributes of coach[A-D] that were persisted into DB. Test attributes such as date of birth, names,
//     * currently coached team, etc..
//     */
//    @Test
//    void attributesTest() {
//        TeamCoachEntity coach;
//        EntityManager em = null;
//        try {
//            em = emf.createEntityManager();
//            em.getTransaction().begin();
//            coach = em.find(TeamCoachEntity.class, teamCoachA.getId());
//            assertEquals(coach.getTeam(), teamA);
//            assertEquals(coach.getName(), "AutistaLeader");
//            assertEquals(coach.getCountry(), CountryEnum.JAPAN);
//            assertEquals(coach.getDateOfBirth(), BIRTH_DATE);
//
//            coach = em.find(TeamCoachEntity.class, teamCoachB.getId());
//            assertEquals(coach.getTeam(), teamA);
//            assertEquals(coach.getName(), "Chiky");
//            assertNull(coach.getCountry());
//            assertNull(coach.getDateOfBirth());
//
//            coach = em.find(TeamCoachEntity.class, teamCoachC.getId());
//            assertEquals(coach.getTeam(), teamB);
//            assertEquals(coach.getName(), "Borat");
//            assertEquals(coach.getCountry(), CountryEnum.HUNGARY);
//            assertEquals(coach.getDateOfBirth(), BIRTH_DATE);
//
//            coach = em.find(TeamCoachEntity.class, teamCoachD.getId());
//            assertEquals(coach.getTeam(), teamB);
//            assertEquals(coach.getName(), "Jupiter");
//            assertEquals(coach.getCountry(), CountryEnum.LAOS);
//            assertEquals(coach.getDateOfBirth(), LocalDate.of(1990,12,1));
//            em.getTransaction().commit();
//        } finally {
//            if (em != null) em.close();
//        }
//    }
//
//    /**
//     * Checks functionality of methods possible for coach, such as addition of new coach, signing of new players,
//     * removing players form the current roster, signing team for the tournament.
//     */
//    @Test
//    void relationshipTeamEntity() {
//        TeamEntity team;
//        EntityManager em = null;
//        try {
//            em = emf.createEntityManager();
//            em.getTransaction().begin();
//            team = em.find(TeamEntity.class, teamA.getId());
//            assertEquals(team.getCoachList(), new HashSet<>(List.of(teamCoachA,teamCoachB)));
//            assertEquals(team.getPlayerList(), new HashSet<>(List.of(playerA)));
//
//            team = em.find(TeamEntity.class, teamB.getId());
//            assertEquals(team.getCoachList(), new HashSet<>(List.of(teamCoachC,teamCoachD)));
//            assertEquals(team.getPlayerList(), new HashSet<>(List.of()));
//
//            team = em.find(TeamEntity.class, teamC.getId());
//            assertEquals(team.getCoachList(), new HashSet<>(List.of(teamCoachE)));
//            assertEquals(team.getPlannedTournaments(), new HashSet<>(List.of(tournamentA)));
//            em.getTransaction().commit();
//        } finally {
//            if (em != null) em.close();
//        }
//    }
//
//    @Test
//    void relationshipTeamManagerEntity() {
//        TeamCoachEntity teamManager;
//        EntityManager em = null;
//        try {
//            em = emf.createEntityManager();
//            em.getTransaction().begin();
//            teamManager = em.find(TeamCoachEntity.class, teamCoachA.getId());
//            assertEquals(teamManager.getTeam(), teamA);
//            teamManager = em.find(TeamCoachEntity.class, teamCoachB.getId());
//            assertEquals(teamManager.getTeam(), teamA);
//
//            teamManager = em.find(TeamCoachEntity.class, teamCoachC.getId());
//            assertEquals(teamManager.getTeam(), teamB);
//            teamManager = em.find(TeamCoachEntity.class, teamCoachD.getId());
//            assertEquals(teamManager.getTeam(), teamB);
//            em.getTransaction().commit();
//        } finally {
//            if (em != null) em.close();
//        }
//    }
//
//    @AfterAll
//    public void afterAll() {
//        EntityManager em = null;
//        try {
//            em = emf.createEntityManager();
//            em.getTransaction().begin();
//            em.createQuery("delete from TeamCoachEntity").executeUpdate();
//            em.getTransaction().commit();
//        } finally {
//            if (em != null) {
//                em.close();
//            }
//        }
//    }
//}
