package cz.muni.fi.pa165.rest.controllers;

import cz.muni.fi.pa165.dto.CreatePlayerDTO;
import cz.muni.fi.pa165.dto.PlayerDTO;
import cz.muni.fi.pa165.entity.PlayerEntity;
import cz.muni.fi.pa165.facade.PlayerFacade;
import cz.muni.fi.pa165.rest.RootUris;
import cz.muni.fi.pa165.rest.exception.ResourceAlreadyExistsException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@RestController
@RequestMapping(RootUris.restPlayer)
public class PlayerController {

    @Autowired
    private PlayerFacade playerFacade;

    @RequestMapping(value = "/{uuid}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
    public final PlayerDTO findById(@PathVariable("uuid") String uuid) {
        return playerFacade.getPlayerById(uuid);
    }

    @RequestMapping(method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
    public final List<PlayerDTO> findAll() {
        return playerFacade.findAllPlayers();
    }

    @RequestMapping(value = "/create", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE,
            produces = MediaType.APPLICATION_JSON_VALUE)
    public final PlayerDTO create(@RequestBody PlayerDTO player) {
        try {
            String  uuid = playerFacade.createPlayer(player);
            return playerFacade.getPlayerById(uuid);
        } catch (Exception e) {
            throw new ResourceAlreadyExistsException();
        }
    }
}
